﻿namespace ProjectSeaplane.CollectionGenericObjects;

public interface ICollectionGenericObjects<T>
    where T : class
{
	int Count { get; }

    int MaxCount { set; get; }

    int Insert(T obj, IEqualityComparer<T?>? comparer = null);

    int Insert(T obj, int position, IEqualityComparer<T?>? comparer = null);

    T Remove(int position);

    T? Get(int position);

    CollectionType GetCollectionType { get; }

    IEnumerable<T?> GetItems();

    void CollectionSort(IComparer<T?> comparer);
}
