﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Drawings;

public class DrawingPlaneCompareByColor : IComparer<DrawingPlane?>
{
    public int Compare(DrawingPlane? x, DrawingPlane? y)
    {
        if (x == null || x.EntityPlane == null)
        {
            return 1;
        }

        if (y == null || y.EntityPlane == null)
        {
            return -1;
        }
        var bodycolorCompare = x.EntityPlane.BodyColor.Name.CompareTo(y.EntityPlane.BodyColor.Name);
        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }
        var speedCompare = x.EntityPlane.Speed.CompareTo(y.EntityPlane.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityPlane.Weight.CompareTo(y.EntityPlane.Weight);
    }
}
