﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Drawings;

public class DrawingPlaneCompareByType : IComparer<DrawingPlane?>
{
    public int Compare(DrawingPlane? x, DrawingPlane? y)
    {
        if (x == null || x.EntityPlane == null)
        {
            return 1;
        }

        if (y == null || y.EntityPlane == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityPlane.Speed.CompareTo(y.EntityPlane.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityPlane.Weight.CompareTo(y.EntityPlane.Weight);
    }
}
