﻿using ProjectSeaplane.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ProjectSeaplane.Drawings;

public class DrawingPlaneEqutables : IEqualityComparer<DrawingPlane?>
{
    public bool Equals(DrawingPlane? x, DrawingPlane? y)
    {
        if (x == null || x.EntityPlane == null)
        {
            return false;
        }
        if (y == null || y.EntityPlane == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityPlane.Speed != y.EntityPlane.Speed)
        {
            return false;
        }
        if (x.EntityPlane.Weight != y.EntityPlane.Weight)
        {
            return false;
        }
        if (x.EntityPlane.BodyColor != y.EntityPlane.BodyColor)
        {
            return false;
        }
        if (x is DrawingSeaplane && y is DrawingSeaplane)
        {
            EntitySeaplane _x = (EntitySeaplane)x.EntityPlane;
            EntitySeaplane _y = (EntitySeaplane)x.EntityPlane;
            if (_x.AdditionalColor != _y.AdditionalColor)
            {
                return false;
            }
            if (_x.Floats != _y.Floats)
            {
                return false;
            }
            if (_x.InflatableBoat != _y.InflatableBoat)
            {
                return false;
            }
        }
        return true;
    }
    public int GetHashCode([DisallowNull] DrawingPlane obj)
    {
        return obj.GetHashCode();
    }
}
